// SendLightMail.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <ras.h>

#include "shphoneClientlibWrapper.h"
#include "Util.h"
#include "resource.h"

/* Defines */
#define LIGHTMAIL_WINDOW_NAME				_T("Cg[ ")
#define LIGHTMAIL_APP_PATH					_T("\\Windows\\lightmail.exe")
#define LIGHTMAIL_APP_ARG_BACKGROUND		_T("-t")

#define SENDLIGHTMAIL_OPT_NOUI				_T("-noui")
#define SENDLIGHTMAIL_OPT_NOSUCCESSUI		_T("-nosuccessui")
#define SENDLIGHTMAIL_OPT_DISCONNECT		_T("-disconnect")

#define SENDLIGHTMAIL_WINDOW_CLASS_NAME		_T("SendLightMail Application Class")
#define SENDLIGHTMAIL_WINDOW_TITLE_NAME		_T("SendLightMail")
#define SENDLIGHTMAIL_MUTEX_NAME			_T("SendLightMail Application Mutex")

#define SENDLIGHTMAIL_END_TIMERID			666
#define SENDLIGHTMAIL_TIMEOUT				(15*1000)	// KȂ̂
#define SENDLIGHTMAIL_STATUS_SUCCESS		0x00000000
#define SENDLIGHTMAIL_STATUS_FAIL			0x00000001
#define SENDLIGHTMAIL_STATUS_TIMEOUT		0x00000002
#define WM_SENDSTART						(WM_APP + 1)

/* Typedefs */
typedef struct {
	TCHAR	szSendNumber[MAX_SENDNUMBER_LEN];
	TCHAR	szSendFileName[MAX_PATH + 1];
	BOOL	bNoUI;
	BOOL	bNoSuccessUI;
	BOOL	bDisconnect;
} PROGRAM_OPTIONS;

typedef struct {
	char	szSendNumber[MAX_SENDNUMBER_LEN];
	char	szSendData[MAX_SENDDATA_LEN];
} SENDLIGHTMAILINFO;


/* Global Variables */
static HINSTANCE			g_hInst = NULL;
static PROGRAM_OPTIONS		g_programOptions;
static SENDLIGHTMAILINFO	g_sendLightMailInfo;

/* ProtoTypes */
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);


static
BOOL
IsPPPConnected()
{
	BOOL		bRet;
	RASCONN		rasConn;
	DWORD		dwSize = 0;
	DWORD		dwCnt = 0;

	bRet = FALSE;

	memset(&rasConn, 0, sizeof(rasConn));
	rasConn.dwSize = sizeof(RASCONN);
	dwSize = sizeof(RASCONN);

	if (RasEnumConnections(&rasConn, &dwSize, &dwCnt) == 0) {
		if (dwCnt > 0) {
			RASCONNSTATUS	rasConnStatus;

			memset(&rasConnStatus, 0, sizeof(rasConnStatus));
			rasConnStatus.dwSize = sizeof(RASCONNSTATUS);
			if(RasGetConnectStatus(rasConn.hrasconn, &rasConnStatus) == 0) {
				if(_tcscmp(rasConnStatus.szDeviceType, RASDT_Modem) == 0) {
					bRet = TRUE;
				}
			}
		}
	}

	return bRet;
}

static
BOOL
DisconnectPPP(
)
{
	BOOL		bRet;
	RASCONN		rasConn;
	DWORD		dwSize = 0;
	DWORD		dwCnt = 0;

	bRet = FALSE;

	memset(&rasConn, 0, sizeof(rasConn));
	rasConn.dwSize = sizeof(RASCONN);
	dwSize = sizeof(RASCONN);

	if (RasEnumConnections(&rasConn, &dwSize, &dwCnt) == 0) {
		if (dwCnt > 0) {
			RASCONNSTATUS	rasConnStatus;

			memset(&rasConnStatus, 0, sizeof(rasConnStatus));
			rasConnStatus.dwSize = sizeof(RASCONNSTATUS);
			if(RasGetConnectStatus(rasConn.hrasconn, &rasConnStatus) == 0) {
				if(_tcscmp(rasConnStatus.szDeviceType, RASDT_Modem) == 0) {
					if (RasHangUp(rasConn.hrasconn) == 0) {
						bRet = TRUE;
					}
				}
			}
		}
	}

	return bRet;
}

static
BOOL
IsLightMailAppAlive()
{
	BOOL	bRet;
	HWND	hWnd;

	bRet = FALSE;

	hWnd = FindWindow(NULL, LIGHTMAIL_WINDOW_NAME);
	if (hWnd != NULL) {
		bRet = TRUE;
	}

	return bRet;
}

static
BOOL
KillLightMailApp()
{
	int		i;
	BOOL	bRet;
	HWND	hWnd;

	bRet = FALSE;

	hWnd = FindWindow(NULL, LIGHTMAIL_WINDOW_NAME);
	if (hWnd != NULL) {
		PostMessage(hWnd, WM_DESTROY, 0, 0);

		for (i = 0; i < 20; i++) {
			hWnd = FindWindow(NULL, LIGHTMAIL_WINDOW_NAME);
			if (hWnd == NULL) {
				bRet = TRUE;
				break;
			}
			Sleep(200);
		}
	}

	return bRet;
}

static
BOOL
InvokeLightMailApp()
{
	BOOL	bRet;
	PROCESS_INFORMATION pi;
	TCHAR	szLightMailCmd[64];
	TCHAR	szLightMailArg[16];

	memset(&pi, 0, sizeof(pi));

	_tcscpy(szLightMailCmd, LIGHTMAIL_APP_PATH);
	_tcscpy(szLightMailArg, LIGHTMAIL_APP_ARG_BACKGROUND);

	bRet = ::CreateProcess(
					szLightMailCmd,
					szLightMailArg,
					NULL,
					NULL,
					NULL,
					NULL,
					0,
					NULL,
					NULL,
					&pi);

	if (bRet) {
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
	}

	return bRet;
}

static
BOOL
ParseParam(
	LPTSTR lpCmdLine,
	PROGRAM_OPTIONS* pOptions
)
{
	BOOL	bRet;
	LPTSTR	pParam = NULL;
	DWORD	dwArgs = 0;

	bRet = FALSE;

	memset(pOptions, 0, sizeof(PROGRAM_OPTIONS));

	if (lpCmdLine != NULL) {
		pParam = _tcstok(lpCmdLine, _T(" "));
		while (pParam != NULL) {
			if (_tcsicmp(pParam, SENDLIGHTMAIL_OPT_NOUI) == 0) {
				pOptions->bNoUI = TRUE;
			}
			else if (_tcsicmp(pParam, SENDLIGHTMAIL_OPT_NOSUCCESSUI) == 0) {
				pOptions->bNoSuccessUI = TRUE;
			}
			else if (_tcsicmp(pParam, SENDLIGHTMAIL_OPT_DISCONNECT) == 0) {
				pOptions->bDisconnect = TRUE;
			}
			else {
				if (dwArgs == 0) {
					_tcscpy(pOptions->szSendNumber, pParam);
				}
				else if (dwArgs == 1) {
					_tcscpy(pOptions->szSendFileName, pParam);
				}

				dwArgs++;
			}
			pParam = _tcstok(NULL, _T(" "));
		}
	}

	if (dwArgs == 2) {
		bRet = TRUE;
	}

	return bRet;

}

static
BOOL
LoadSendDataFromFile(
	LPTSTR	szFileName,	// IN
	LPSTR	pSendData	// OUT
)
{
	BOOL	bRet = FALSE;
	TCHAR	szPath[MAX_PATH + 1];
	HANDLE	hFile = INVALID_HANDLE_VALUE;
	
	bRet = FALSE;

	if (szFileName == NULL || pSendData == NULL) {
		return bRet;
	}

	if (szFileName[0] == TEXT('\\')) {
		_tcscpy(szPath, szFileName);
	}
	else {
		LPTSTR	p = NULL;
		GetModuleFileName(NULL, szPath, sizeof(szPath)/sizeof(szPath[0]));
		p = _tcsrchr(szPath, _T('\\'));
		if (p != NULL) {
			*(p+1) = _T('\0');
			_tcscat(szPath, szFileName);
		}
		else {
			_tcscpy(szPath, szFileName);
		}
	}

	hFile = CreateFile(szPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile != INVALID_HANDLE_VALUE) {
		DWORD	dwReaded;
		char	szSendData[MAX_SENDDATA_LEN];

		memset(szSendData, 0, sizeof(szSendData));
		bRet = ReadFile(hFile, szSendData, sizeof(szSendData)-1, &dwReaded, NULL);
		if (bRet) {
			strcpy(pSendData, szSendData);
		}

		CloseHandle(hFile);
		hFile = NULL;
	}

	return bRet;

}

static
ATOM
MyRegisterClass(
	HINSTANCE hInstance,
	LPTSTR szWindowClass
)
{
	WNDCLASS	wc;

    wc.style			= 0;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= 0;
    wc.hCursor			= 0;
    wc.hbrBackground	= 0;
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}


static
BOOL
InitInstance(
	HINSTANCE hInstance,
	int nCmdShow
)
{
	HWND	hWnd = NULL;

	g_hInst = hInstance;

	hWnd = FindWindow(SENDLIGHTMAIL_WINDOW_CLASS_NAME, SENDLIGHTMAIL_WINDOW_TITLE_NAME);	
	if (hWnd) {
		return FALSE;
	} 

	MyRegisterClass(hInstance, SENDLIGHTMAIL_WINDOW_CLASS_NAME);

	hWnd = CreateWindow(SENDLIGHTMAIL_WINDOW_CLASS_NAME, SENDLIGHTMAIL_WINDOW_TITLE_NAME, 0, 0, 0, 0, 0, NULL, NULL, hInstance, NULL);
	if (!hWnd) {	
		return FALSE;
	}

	return TRUE;
}


static
int
SendLightMailProc(
	HINSTANCE			hInstance,
	int					nCmdShow
)
{
	MSG		msg;
	BOOL	bLightMailAppAlive = TRUE;
	char	szSendNumber[MAX_SENDNUMBER_LEN];
	char	szSendData[MAX_SENDDATA_LEN];
	int		iRet;

	iRet = 0;	// default return value

	memset(szSendNumber, 0, sizeof(szSendNumber));
	WideCharToMultiByte(CP_ACP, 0, g_programOptions.szSendNumber, -1, szSendNumber, sizeof(szSendNumber), NULL, NULL);

	// {f[^t@Cǂݍ
	memset(szSendData, 0, sizeof(szSendData));
	if (LoadSendDataFromFile(g_programOptions.szSendFileName, szSendData)) {

		memset(&g_sendLightMailInfo, 0, sizeof(g_sendLightMailInfo));
		strcpy(g_sendLightMailInfo.szSendNumber, szSendNumber);
		strcpy(g_sendLightMailInfo.szSendData, szSendData);


		if (g_programOptions.bDisconnect) {
			// _CAAbvȂΐؒf
			if (IsPPPConnected()) {
				DisconnectPPP();
			}
		}

		// Cg[AvNȂΏI
		bLightMailAppAlive = IsLightMailAppAlive();
		if (bLightMailAppAlive) {
			if (!KillLightMailApp()) {
				if (!g_programOptions.bNoUI) {
					Util_MessageBox(NULL, hInstance, IDS_KILLLIGHTMAIL_FAIL, IDS_CAPTION, MB_OK|MB_ICONERROR|MB_SETFOREGROUND);
				}
				return 0;
			}
		}

		// WndProcŃCg[̑Ms
		if (InitInstance (hInstance, nCmdShow)) {
			while (GetMessage(&msg, NULL, 0, 0)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}

			iRet = msg.wParam;
		}

		// Cg[AvIĂꍇ͍ċN
		if (bLightMailAppAlive) {
			InvokeLightMailApp();
		}
		//
	}

	return iRet;
}


int
WINAPI
WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow)
{	

 	BOOL			bParseSucc	= FALSE;
	int				iRet		= 0;
	HANDLE			hMutex		= NULL;

	// ̉
	bParseSucc = ParseParam(lpCmdLine, &g_programOptions);
	if (!bParseSucc) {
		return 0;
	}

	// dN`FbN
	hMutex = CreateMutex(NULL, TRUE, SENDLIGHTMAIL_MUTEX_NAME);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {

			if (!g_programOptions.bNoUI) {
				Util_MessageBox(NULL, hInstance, IDS_ALREADY_STARTED, IDS_CAPTION, MB_OK|MB_ICONERROR|MB_SETFOREGROUND);
			}

			CloseHandle(hMutex);
			hMutex = NULL;
			return 0;
		}
	}
	else {
		return 0;
	}

	if (bParseSucc) {
		// Cg[M
		iRet = SendLightMailProc(hInstance, nCmdShow);
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
	hMutex = NULL;
	return iRet;
}

static
LRESULT
CALLBACK
WndProc(
	HWND	hWnd,
	UINT	message,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	static	CshphoneClientlibWrapper*	s_pPhoneLibWrapper	= NULL;
	static	DWORD						s_dwSendStatus		= SENDLIGHTMAIL_STATUS_TIMEOUT;

	switch (message) 
	{
		case WM_CREATE:
			s_pPhoneLibWrapper = new CshphoneClientlibWrapper(hWnd, 0);
			if (s_pPhoneLibWrapper != NULL) {
				PostMessage(hWnd, WM_SENDSTART, 0, 0);
			}
			else {
				return -1;
			}
			break;

		case WM_SENDSTART:
			if (s_pPhoneLibWrapper != NULL) {
				s_pPhoneLibWrapper->SendLightMail(g_sendLightMailInfo.szSendNumber, g_sendLightMailInfo.szSendData);

				SetTimer(hWnd, SENDLIGHTMAIL_END_TIMERID, SENDLIGHTMAIL_TIMEOUT, 0);
			}
			break;

		case WM_TIMER:
			if (wParam == SENDLIGHTMAIL_END_TIMERID) {
				BOOL	bRetry;
				int		iRet;

				KillTimer(hWnd, SENDLIGHTMAIL_END_TIMERID);

				if (s_pPhoneLibWrapper != NULL) {
					s_pPhoneLibWrapper->ReleaseChannel();
				}

				bRetry = FALSE;
				switch(s_dwSendStatus) {
				case SENDLIGHTMAIL_STATUS_SUCCESS:
					// M
					if (!g_programOptions.bNoUI && !g_programOptions.bNoSuccessUI) {
						Util_MessageBox(hWnd, g_hInst, IDS_SEND_SUCCESS, IDS_CAPTION, MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);
					}
					break;

				case SENDLIGHTMAIL_STATUS_TIMEOUT:
					// M^CAEg
					if (!g_programOptions.bNoUI) {
						iRet = Util_MessageBox(hWnd, g_hInst, IDS_SEND_TIMEOUT, IDS_CAPTION, MB_RETRYCANCEL|MB_ICONERROR|MB_SETFOREGROUND);
						if (iRet == IDRETRY) {
							bRetry = TRUE;
						}
					}
					break;

				case SENDLIGHTMAIL_STATUS_FAIL:
					// Ms
					if (!g_programOptions.bNoUI) {
						iRet = Util_MessageBox(hWnd, g_hInst, IDS_SEND_FAIL, IDS_CAPTION, MB_RETRYCANCEL|MB_ICONERROR|MB_SETFOREGROUND);
						if (iRet == IDRETRY) {
							bRetry = TRUE;
						}
					}
					break;
				}

				if (bRetry) {
					s_dwSendStatus = SENDLIGHTMAIL_STATUS_TIMEOUT;
					PostMessage(hWnd, WM_SENDSTART, 0, 0);
				}
				else {
					SendMessage(hWnd, WM_CLOSE, 0, 0);
				}
			}
			else {
				return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		case WM_CLOSE:
			DestroyWindow(hWnd);
			break;

		case WM_DESTROY:
			if (s_pPhoneLibWrapper != NULL) {
				delete s_pPhoneLibWrapper;
				s_pPhoneLibWrapper = NULL;
			}

			PostQuitMessage(0);
			break;

		case WM_LIGHTMAIL_EVENT:
			{
				// Cxg͐^ʖڂɉ͂ĂȂ̂œKɂ
				if (wParam == 0x2be) {
					// M
					s_dwSendStatus = SENDLIGHTMAIL_STATUS_SUCCESS;
					SetTimer(hWnd, SENDLIGHTMAIL_END_TIMERID, 10, 0);	// Context؂ւ(Ô)
				}
				else if (wParam == 0x2c0 || wParam == 0x2c1) {
					// Ms
					s_dwSendStatus = SENDLIGHTMAIL_STATUS_FAIL;
					SetTimer(hWnd, SENDLIGHTMAIL_END_TIMERID, 10, 0);	// Context؂ւ(Ô)
				}
				else if (wParam == 0x2c2) {
					// Cg[M
#if 0
					LightMailInfo_TAG	lightMailInfo;

					memset(&lightMailInfo, 0, sizeof(lightMailInfo));
					s_pPhoneLibWrapper->GetLightMailInfo(&lightMailInfo);
#endif
				}
			}
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }

   return 0;
}
