// shphoneClientlibWrapper.cpp: CshphoneClientlibWrapper NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "shphoneClientlibWrapper.h"

/* Defines */
#define CSHPHONECLIENTLIB_INSTANCE_SIZE		4	// CshphoneClientlibNX̃CX^X̃TCY
#define SHPHONELIBDLL_FILE_NAME				_T("shphonelib.dll")
#define CSHPHONECLIENTLIB_CTOR				_T("??0CshphoneClientlib@@QAA@PAUHWND__@@H@Z")
#define CSHPHONECLIENTLIB_DTOR				_T("??1CshphoneClientlib@@QAA@XZ")
#define SENDLIGHTMAIL_FUNC_NAME				_T("?SendLightMail@CshphoneClientlib@@QAAXPAD0@Z")
#define	GETLIGHTMAILINFO_FUNC_NAME			_T("?GetLightMailInfo@CshphoneClientlib@@QAAHPAULightMailInfo_TAG@@@Z")
#define RELEASECHANNEL_FUNC_NAME			_T("?ReleaseChannel@CshphoneClientlib@@QAAXXZ")


/* Globals */
int CshphoneClientlibWrapper::ms_nRef = 0;
HMODULE				CshphoneClientlibWrapper::ms_hModule = NULL;
SHPHONECLIENTLIBIF	CshphoneClientlibWrapper::ms_Entry;


static
HMODULE
LoadCshphoneClientlib(
	SHPHONECLIENTLIBIF*	pEntry
)
{
	HMODULE						hModule = NULL;
	PFNCSHPHONECLIENTLIB_CTOR	pfnCshphoneClientlib_Ctor	= NULL;
	PFNCSHPHONECLIENTLIB_DTOR	pfnCshphoneClientlib_Dtor	= NULL;
	PFNSENDLIGHTMAIL			pfnSendLightMail			= NULL;
	PFNGETLIGHTMAILINFO			pfnGetLightMailInfo			= NULL;
	PFNRELEASECHANNEL			pfnReleaseChannel			= NULL;
	
	hModule = LoadLibrary(SHPHONELIBDLL_FILE_NAME);
	if (hModule != NULL) {
		pfnCshphoneClientlib_Ctor	= (PFNCSHPHONECLIENTLIB_CTOR) GetProcAddress(hModule, CSHPHONECLIENTLIB_CTOR);
		pfnCshphoneClientlib_Dtor	= (PFNCSHPHONECLIENTLIB_DTOR) GetProcAddress(hModule, CSHPHONECLIENTLIB_DTOR);
		pfnSendLightMail			= (PFNSENDLIGHTMAIL) GetProcAddress(hModule, SENDLIGHTMAIL_FUNC_NAME);
		pfnGetLightMailInfo			= (PFNGETLIGHTMAILINFO) GetProcAddress(hModule, GETLIGHTMAILINFO_FUNC_NAME);
		pfnReleaseChannel			= (PFNRELEASECHANNEL) GetProcAddress(hModule, RELEASECHANNEL_FUNC_NAME);
		
		if (pfnCshphoneClientlib_Ctor	!= NULL &&
			pfnCshphoneClientlib_Dtor	!= NULL &&
			pfnSendLightMail			!= NULL &&
			pfnGetLightMailInfo			!= NULL &&
			pfnReleaseChannel			!= NULL		) {

			pEntry->pfnCshphoneClientlib_Ctor	= pfnCshphoneClientlib_Ctor;
			pEntry->pfnCshphoneClientlib_Dtor	= pfnCshphoneClientlib_Dtor;
			pEntry->pfnSendLightMail			= pfnSendLightMail;
			pEntry->pfnGetLightMailInfo			= pfnGetLightMailInfo;
			pEntry->pfnReleaseChannel			= pfnReleaseChannel;
		}
		else {
			FreeLibrary(hModule);
			hModule = NULL;
		}
	}

	return hModule;
}

static
void
UnloadCshphoneClientlib(
	HMODULE	hModule
)
{
	FreeLibrary(hModule);
}


//////////////////////////////////////////////////////////////////////

CshphoneClientlibWrapper::CshphoneClientlibWrapper(
	HWND	hWnd,
	int		nID
)
{
	LPBYTE	pInstance = NULL;

	if (ms_nRef == 0) {
		HMODULE				hModule = NULL;
		SHPHONECLIENTLIBIF	entry;

		hModule = LoadCshphoneClientlib(&entry);
		if (hModule != NULL) {
			ms_hModule = hModule;
			memcpy(&ms_Entry, &entry, sizeof(entry));
		}
	}
	ms_nRef++;


	if (ms_Entry.pfnCshphoneClientlib_Ctor != NULL) {
		pInstance = new BYTE[CSHPHONECLIENTLIB_INSTANCE_SIZE];

		if (pInstance != NULL) {
			memset(pInstance, 0, CSHPHONECLIENTLIB_INSTANCE_SIZE);

			(*ms_Entry.pfnCshphoneClientlib_Ctor)(pInstance, hWnd, nID);

			m_pInstance = pInstance;
		}
	}
}

CshphoneClientlibWrapper::~CshphoneClientlibWrapper()
{
	if (m_pInstance != NULL) {
		if (ms_Entry.pfnCshphoneClientlib_Dtor != NULL) {
			(*ms_Entry.pfnCshphoneClientlib_Dtor)(m_pInstance);
		}

		delete [] m_pInstance;
		m_pInstance = NULL;
	}


	ms_nRef--;
	if (ms_nRef == 0) {
		UnloadCshphoneClientlib(ms_hModule);

		ms_hModule = NULL;
		memset(&ms_Entry, 0, sizeof(ms_Entry));
	}
}

void
CshphoneClientlibWrapper::SendLightMail(
	char *szNumber,
	char *szSendData
)
{
	if (ms_hModule != NULL) {
		if (ms_Entry.pfnSendLightMail != NULL) {
			(* ms_Entry.pfnSendLightMail)(m_pInstance, szNumber, szSendData);
		}
	}
}

int
CshphoneClientlibWrapper::GetLightMailInfo(
	LightMailInfo_TAG *pTag
)
{
	int iRet = 0;

	if (ms_hModule != NULL) {
		if (ms_Entry.pfnGetLightMailInfo != NULL) {
			iRet = (* ms_Entry.pfnGetLightMailInfo)(m_pInstance, pTag);
		}
	}

	return iRet;
}

void
CshphoneClientlibWrapper::ReleaseChannel(void)
{
	if (ms_hModule != NULL) {
		if (ms_Entry.pfnReleaseChannel != NULL) {
			(* ms_Entry.pfnReleaseChannel)(m_pInstance);
		}
	}
}
